<?php

namespace app\index\model;

use think\Model;
use app\index\model\BoxModel;

class OrderModel extends Model{

    // 确定链接表名
    protected $name = 'order';

    public function getOne($order_sn){
        return $this->where('order_sn' , $order_sn)->find();
    }

    public function Box()
    {
        return $this->hasOne('BoxModel', 'order_sn', 'order_sn');
    }

    /**
     * 根据既定条件修改信息
     * @where $param
     * @update $param
     */
    public function editData($where,$update)
    {
        try{
            $result = $this->save($update, $where);
            if(false === $result){
                // 验证失败 输出错误信息
                return msg(-1, '', $this->getError());
            }else{

                return msg(1, '', 'success');
            }
        }catch(\Exception $e){
            return msg(-2, '', $e->getMessage());
        }
    }
    /**
     * 检查取件码
    */
    public function check_fcode($code)
    {
        $where['sc_order.code'] = $code;
        $where['BoxModel.box_status'] = 2;
        try{
            $order = $this->Box()->hasWhere($where)->find();
            if(empty($order)){
                // 验证失败 输出错误信息
                return msg(-1, '', $this->getError());
            }else{
                $data['code'] = $code;
                $data['existed'] = true;
                $data['trunk'] = $order['box_number'];
                $data['cabinet'] = $order['cabinet_number'];
                return msg(1, $data, 'success');
            }
        }catch(\Exception $e){
            return msg(-2, '', $e->getMessage());
        }
    }
}